#include "EventFilterChain.h"

DefineClassSingle(EventFilterChain);

//--------------------------------------------------------------------------------

EventFilterChain::EventFilterChain()
{
}

//--------------------------------------------------------------------------------

EventFilterChain::~EventFilterChain()
{
}

//--------------------------------------------------------------------------------

	static Boolean FilterEventProc(const void* ref, EventFilter::NextFilterPtr linkToCheck)
	{
		EventFilter*	filter = linkToCheck;
		ToolboxEvent*	event  = (ToolboxEvent*) ref;

		return filter->FilterEvent(*event);
	}

bool EventFilterChain::FilterEvent(ToolboxEvent& evt)
{
	EventFilter::NextFilterPtr handler = fFilters.FindLink(FilterEventProc, &evt);

	EventFilter* filter = handler;

	return handler;
}

//--------------------------------------------------------------------------------

	struct FilterAEInfo
	{
		EventRecord& 			event;
		long					returnID;
		long					transactionID;
		const AEAddressDesc&	sender;
		
		FilterAEInfo(EventRecord& anEvent, long aReturnID, long aTransactionID, const AEAddressDesc& aSender)
		:	event(anEvent), returnID(aReturnID), transactionID(aTransactionID), sender(aSender) {}
	};
	
	static Boolean FilterAppleEventProc(const void* ref, EventFilter::NextFilterPtr linkToCheck)
	{
		EventFilter*	filter	= linkToCheck;
		FilterAEInfo*	info	= (FilterAEInfo*) ref;

		return filter->FilterAppleEvent(info->event, info->returnID, info->transactionID, info->sender);
	}

bool EventFilterChain::FilterAppleEvent(EventRecord& event, long returnID, long transactionID, const AEAddressDesc& sender)
{
	FilterAEInfo info(event, returnID, transactionID, sender);

	EventFilter::NextFilterPtr handler = fFilters.FindLink(FilterAppleEventProc, &info);

	EventFilter* filter = handler;

	return handler;
}

//--------------------------------------------------------------------------------

