#pragma once

#include "Object.h"
#include "ObjectList.h"

/*

				TObject
				/	|
			ClassA	|
			/	\	|
		ClassB	ClassC
			\	/
			ClassD

*/


class ClassA : public virtual TObject
{
	DeclareClass();
public:
	int fVariableA;
	
	ClassA(int k) : fVariableA(k) {}
};


class ClassB : public ClassA
{
	DeclareClass();
public:
	int fVariableB;
	
	
	ClassB(int k) : ClassA(k*2), fVariableB(k) {}
};


class ClassC : public ClassA, public virtual TObject
{
	DeclareClass();
public:
	int fVariableC;
	
	
	ClassC(int k) : ClassA(k*8), fVariableC(k) {}
};


class ClassD :
	public virtual ClassB,
	public virtual ClassC
{
	DeclareClass();
public:
	int fVariableD;
	
	ClassD(int a, int b, int c) : ClassB(b), ClassC(c), fVariableD(69) { a; }
	
};


void InspectorTest(void);
